﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PuzzleSolve
{
    class Program
    {
        static void Main(string[] args)
        {
            // Load Puzzle Pieces

            PuzzlePiece[] pieces = new PuzzlePiece[9];

            pieces[0] = new PuzzlePiece(1, new PuzzleSide(3, true), new PuzzleSide(1, false), new PuzzleSide(2, true), new PuzzleSide(1, false));
            pieces[1] = new PuzzlePiece(2, new PuzzleSide(2, false), new PuzzleSide(3, false), new PuzzleSide(4, false), new PuzzleSide(1, true));
            pieces[2] = new PuzzlePiece(3, new PuzzleSide(3, false), new PuzzleSide(1, true), new PuzzleSide(2, true), new PuzzleSide(4, false));
            pieces[3] = new PuzzlePiece(4, new PuzzleSide(4, true), new PuzzleSide(2, true), new PuzzleSide(3, false), new PuzzleSide(1, true));
            pieces[4] = new PuzzlePiece(5, new PuzzleSide(3, false), new PuzzleSide(4, true), new PuzzleSide(1, false), new PuzzleSide(2, true));
            pieces[5] = new PuzzlePiece(6, new PuzzleSide(4, false), new PuzzleSide(2, false), new PuzzleSide(4, false), new PuzzleSide(1, true));
            pieces[6] = new PuzzlePiece(7, new PuzzleSide(4, true), new PuzzleSide(3, true), new PuzzleSide(2, true), new PuzzleSide(1, false));
            pieces[7] = new PuzzlePiece(8, new PuzzleSide(2, false), new PuzzleSide(1, true), new PuzzleSide(4, false), new PuzzleSide(3, true));
            pieces[8] = new PuzzlePiece(9, new PuzzleSide(3, false), new PuzzleSide(3, true), new PuzzleSide(2, true), new PuzzleSide(4, true));

            PuzzleSolutionSet Solutions = new PuzzleSolutionSet();
            for (int solution = 0; solution < 500; solution++)
            {
                Console.WriteLine("Attempting Solution {0}", solution);
                PuzzlePlacement[,] PuzzleSolution = new PuzzlePlacement[5, 5];

                for (int x = 0; x < 5; x++)
                {
                    for (int y = 0; y < 5; y++)
                    {
                        PuzzleSolution[x, y] = new PuzzlePlacement(new PuzzlePiece(0, new PuzzleSide(0, true), new PuzzleSide(0, true), new PuzzleSide(0, true), new PuzzleSide(0, true)), 0);
                    }
                }

                for (int x = 1; x < 4; x++)
                {
                    for (int y = 1; y < 4; y++)
                    {
                        for (int pieceIndex = 0; pieceIndex < 9; pieceIndex++)
                        {
                            for (int orientation = 0; orientation < 4; orientation++)
                            {
                                if (pieces[pieceIndex].Match(orientation, PuzzleSolution[x, y - 1], PuzzleSolution[x - 1, y], PuzzleSolution[x + 1, y], PuzzleSolution[x, y + 1]))
                                {
                                    // match, has the piece already been used?
                                    if (!PuzzlePlacement.Used(PuzzleSolution, pieces[pieceIndex]))
                                    {
                                        PuzzleSolution[x, y] = new PuzzlePlacement(pieces[pieceIndex], orientation);
                                        if (!Solutions.PreviouslyAttempted(PuzzleSolution)) break;
                                        else PuzzleSolution[x, y] = new PuzzlePlacement(new PuzzlePiece(0, new PuzzleSide(0, true), new PuzzleSide(0, true), new PuzzleSide(0, true), new PuzzleSide(0, true)), 0);
                                    }
                                }
                                if (PuzzleSolution[x, y].GetPuzzleSide(PuzzleSideLocation.Top).Match != 0) break;  // If we have a match don't try another orientation
                            }
                            if (PuzzleSolution[x, y].GetPuzzleSide(PuzzleSideLocation.Top).Match != 0) break;
                        }
                        if (PuzzleSolution[x, y].GetPuzzleSide(PuzzleSideLocation.Top).Match == 0) break;                        
                    }
                    if (PuzzleSolution[x, 3].GetPuzzleSide(PuzzleSideLocation.Top).Match == 0) break;                        
                }
                if (PuzzleSolution[3, 3].GetPuzzleSide(PuzzleSideLocation.Top).Match != 0)
                {
                    // Solved
                    Console.WriteLine("Solved");
                    for (int x = 1; x < 4; x++)
                    {
                        for (int y = 1; y < 4; y++)
                        {
                            PuzzlePlacement place = PuzzleSolution[x,y];
                            Console.WriteLine("Location ({0}, {1}) = {2} in orientation {3}", x, y, place.Piece.PieceId, (PuzzleSideLocation)place.Orientation); 
                        }
                    }
                    Console.WriteLine("Done");
                    return;
                }
                Solutions.Solutions.Add(PuzzleSolution);
            }
            Console.WriteLine("Unable to solve the puzzle");
        }
    }
}
